#Include "win32api.inc"

Type TItem
  Value    As Long
  NextItem As TItem Ptr
  PrevItem As TItem Ptr
End Type

Global hHeap As Long
Global Head  As TItem Ptr
Global Tail  As TItem Ptr

Function Enqueue(ByVal Value As Long) As Long
  Local NewItem As TItem Ptr
  NewItem = HeapAlloc(hHeap, %NULL, SizeOf(TItem))

  If NewItem = %NULL Then
    Print "HeapAlloc Failed."
    Function = 0
    Exit Function
  End If

  @NewItem.Value    = Value
  @NewItem.NextItem = %NULL
  @NewItem.PrevItem = Tail

  If Head = %NULL Then
    Print "Enqueuing first item at: ", NewItem
    Head = NewItem
    Tail = NewItem
  Else
    Print "Enqueuing item at: ", NewItem
    @Tail.NextItem = NewItem
    Tail = NewItem
  End If

  Function = 1
End Function

Function Dequeue As Long
  If Tail = %NULL Then
    ? "List is empty"
    Function = 0
    Exit Function
  End If

  Dim Result As Long, Temp As Long
  Result = @Tail.Value
  Temp   = @Tail.PrevItem


  Print "Dequeuing item at:", Tail
  HeapFree hHeap, %NULL, Tail

  Tail = Temp
  If Tail = %NULL Then
    Head = %NULL
  Else
    @Tail.NextItem = %NULL
  End If

  Print "New tail at:", Tail

  Function = Result
End Function




Function PbMain
  hHeap = HeapCreate(%NULL, 1000000, 0)

  If hHeap = %NULL Then
    Print "HeapCreate Failed."
    Exit Function
  End If

  Head = %NULL
  Tail = %NULL

  Enqueue 1
  Enqueue 2
  Enqueue 3
  Enqueue 4
  Dequeue
  Enqueue 5
  Enqueue 6
  Dequeue

  PrintAll

  HeapDestroy hHeap

  WaitKey$
End Function
